// BoBTweakDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BoBTweak.h"
#include "BoBTweakDlg.h"
#include "DlgProxy.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBoBTweakDlg dialog

IMPLEMENT_DYNAMIC(CBoBTweakDlg, CDialog);

CBoBTweakDlg::CBoBTweakDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBoBTweakDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoBTweakDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
	m_xPosition = -1;
	m_yPosition = -1;
	m_Burble = TRUE;
	m_DisableCDCheck = FALSE;
	m_KeepOnTop = FALSE;
	m_AdvancedScienceKit = FALSE;
	m_EttinGrendelSelector = FALSE;
	m_InfiniteScroll = FALSE;
	m_NeuroscienceKit = FALSE;
	m_ScienceKit = FALSE;
	m_nAppID = 0;
}

CBoBTweakDlg::~CBoBTweakDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CBoBTweakDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoBTweakDlg)
	DDX_Control(pDX, IDC_MACRO_REPLY, m_MacroReply);
	DDX_Control(pDX, IDC_MACRO, m_Macro);
	DDX_Control(pDX, IDC_MAINTAB, m_MainTab);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBoBTweakDlg, CDialog)
	//{{AFX_MSG_MAP(CBoBTweakDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_MOVE()
	ON_NOTIFY(TCN_SELCHANGING, IDC_MAINTAB, OnSelchangingMaintab)
	ON_NOTIFY(TCN_SELCHANGE, IDC_MAINTAB, OnSelchangeMaintab)
	ON_COMMAND(ID_TESTING_BURBLE, OnTestingBurble)
	ON_COMMAND(ID_CHEATMODES_NONE, OnCheatmodesNone)
	ON_COMMAND(ID_CHEATMODES_BLUEBERY4, OnCheatmodesBluebery4)
	ON_COMMAND(ID_CHEATMODES_COCONUTGROVE, OnCheatmodesCoconutgrove)
	ON_COMMAND(ID_FILE_NEW_WORLD, OnFileNewWorld)
	ON_COMMAND(ID_FILE_OPEN_WORLD, OnFileOpenWorld)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_SAVE_WORLD, OnFileSaveWorld)
	ON_COMMAND(ID_TESTING_ACTIVATE_GAME_STATES, OnTestingActivateGameStates)
	ON_COMMAND(ID_CHEATMODES_DISABLECDCHECK, OnCheatmodesDisablecdcheck)
	ON_COMMAND(ID_TESTING_CREATE_FEMALE_NORN, OnTestingCreateFemaleNorn)
	ON_COMMAND(ID_TESTING_CREATE_MALE_NORN, OnTestingCreateMaleNorn)
	ON_COMMAND(ID_TESTING_EUTHANASIA, OnTestingEuthanasia)
	ON_COMMAND(ID_TESTING_FORCE_AGEING, OnTestingForceAgeing)
	ON_COMMAND(ID_TESTING_INFECT_NORN, OnTestingInfectNorn)
	ON_COMMAND(ID_TESTING_INSTANT_GOAL_DIRECTION, OnTestingInstantGoalDirection)
	ON_COMMAND(ID_TESTING_INSTANT_VOCAB, OnTestingInstantVocab)
	ON_COMMAND(ID_TESTING_MARK_ALL_ROOMS_VISITED, OnTestingMarkAllRoomsVisited)
	ON_COMMAND(ID_TESTING_RESET_MUTATION_COUNT, OnTestingResetMutationCount)
	ON_COMMAND(ID_TESTING_SHOW_MAP, OnTestingShowMap)
	ON_BN_CLICKED(ID_WINDOW_HIDE, OnWindowHide)
	ON_BN_CLICKED(ID_WINDOW_KEEP_ON_TOP, OnWindowKeepOnTop)
	ON_BN_CLICKED(IDC_EXECUTE_MACRO, OnExecuteMacro)
	ON_BN_CLICKED(IDC_CHECK_ADVSCIENCEKIT, OnCheckAdvsciencekit)
	ON_BN_CLICKED(IDC_CHECK_ETTINGRENDELSELECTOR, OnCheckEttingrendelselector)
	ON_BN_CLICKED(IDC_CHECK_INFINITESCROLL, OnCheckInfinitescroll)
	ON_BN_CLICKED(IDC_CHECK_NEUROSCIENCEKIT, OnCheckNeurosciencekit)
	ON_BN_CLICKED(IDC_CHECK_SCIENCEKIT, OnCheckSciencekit)
	ON_BN_CLICKED(ID_CHEATS_RESTOCKHATCHERY, OnCheatsRestockhatchery)
	ON_BN_CLICKED(ID_TESTING_INSTANT_VOCAB, OnTestingInstantVocab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoBTweakDlg message handlers

BOOL CBoBTweakDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Get saved settings
	LoadSettings();

	// Reposition window according to saved co-ordinates
	if (m_xPosition >= 0 && m_yPosition >= 0)
	{
		SetWindowPos(NULL, m_xPosition, m_yPosition, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
	}
	
	if (m_KeepOnTop)
	{
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		CheckDlgButton(ID_WINDOW_KEEP_ON_TOP, 1);
	}
	else
	{
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		CheckDlgButton(ID_WINDOW_KEEP_ON_TOP, 0);
	}

	// Load initial settings from Creatures
	LONG nResult;
	HKEY hKey;
	DWORD dwTemp;
	DWORD dwLen;
	TCHAR szTemp[256];

	m_Burble = TRUE;
	m_Privileges = "user";
	m_DisableCDCheck = FALSE;
	m_AdvancedScienceKit = FALSE;
	m_EttinGrendelSelector = FALSE;
	m_InfiniteScroll = FALSE;
	m_NeuroscienceKit = FALSE;
	m_ScienceKit = FALSE;

	nResult = RegOpenKey(HKEY_CURRENT_USER, _T("Software\\CyberLife Technology\\Creatures 2\\1.0"), &hKey);
	if (nResult == ERROR_SUCCESS)
	{
		dwTemp = TRUE;
		dwLen = sizeof(dwTemp);
		nResult = RegQueryValueEx(hKey, _T("Burble"), NULL, NULL, (LPBYTE)&dwTemp, &dwLen);
		if (nResult == ERROR_SUCCESS)
		{
			m_Burble = (dwTemp != 0);
		}

		_tcscpy(szTemp, _T("user"));
		dwLen = 256;
		nResult = RegQueryValueEx(hKey, _T("Privileges"), NULL, NULL, (LPBYTE)&szTemp, &dwLen);
		if (nResult == ERROR_SUCCESS)
		{
			m_Privileges = szTemp;
		}

		RegCloseKey(hKey);
	}

	nResult = RegOpenKey(HKEY_LOCAL_MACHINE, _T("Software\\CyberLife Technology\\Creatures 2\\1.0"), &hKey);
	if (nResult == ERROR_SUCCESS)
	{
		dwLen = 256;
		nResult = RegQueryValueEx(hKey, _T("No CD-ROM needed"), NULL, NULL, (LPBYTE)&szTemp, &dwLen);
		if (nResult == ERROR_SUCCESS)
		{
			m_DisableCDCheck = TRUE;
		}

		RegCloseKey(hKey);
	}

	CString sValue;

	SendCAOSCommand(CString(_T("dde: putv game 1 5")), &sValue);
	m_AdvancedScienceKit = (sValue != "0");

	SendCAOSCommand(CString(_T("dde: putv game 2 0")), &sValue);
	m_EttinGrendelSelector = (sValue != "0");

	SendCAOSCommand(CString(_T("dde: putv game 2 1")), &sValue);
	m_InfiniteScroll = (sValue != "0");
	
	SendCAOSCommand(CString(_T("dde: putv game 0 6")), &sValue);
	m_NeuroscienceKit = (sValue != "0");
	
	SendCAOSCommand(CString(_T("dde: putv game 0 5")), &sValue);
	m_ScienceKit = (sValue != "0");

	// Setup controls
	TC_ITEM tabCtrlItem;
	CString sTabTitle;

	tabCtrlItem.mask = TCIF_TEXT;

	// Add tab 0
	sTabTitle.LoadString(IDS_TAB_QUICKFUNCTIONS);
	tabCtrlItem.pszText = sTabTitle.GetBuffer(0);
	m_MainTab.InsertItem(0, &tabCtrlItem);
	sTabTitle.ReleaseBuffer();

	// Add tab 1
	sTabTitle.LoadString(IDS_TAB_GAMESTATES);
	tabCtrlItem.pszText = sTabTitle.GetBuffer(0);
	m_MainTab.InsertItem(1, &tabCtrlItem);
	sTabTitle.ReleaseBuffer();

	// Add tab 2
	sTabTitle.LoadString(IDS_TAB_CLI);
	tabCtrlItem.pszText = sTabTitle.GetBuffer(0);
	m_MainTab.InsertItem(2, &tabCtrlItem);
	sTabTitle.ReleaseBuffer();

	// Select tab
	m_MainTab.SetCurSel(m_Page);
	ShowTab(m_Page, TRUE);

	// Initialise menu items
	UpdateMenus();

	UpdateGameStateChecks();

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBoBTweakDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		((CBoBTweakApp*)AfxGetApp())->OnAppAbout();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CBoBTweakDlg::OnDestroy()
{
	SaveSettings();

	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBoBTweakDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBoBTweakDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CBoBTweakDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CBoBTweakDlg::OnOK() 
{
	/*if (GetFocus() == &m_Macro)
		OnExecuteMacro();*/
	/*if (CanExit())
		CDialog::OnOK();*/
}

void CBoBTweakDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CBoBTweakDlg::CanExit()
{
	CString sCommand;

	if (m_nAppID)
	{
		sCommand.Format(_T("app: quit %d"), m_nAppID);
		SendCAOSCommand(sCommand, NULL);
	}

	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

void CBoBTweakDlg::OnMove(int x, int y) 
{
	CRect windowRect;

	CDialog::OnMove(x, y);
	
	GetWindowRect(&windowRect);

	m_xPosition = windowRect.left;
	m_yPosition = windowRect.top;
}

void CBoBTweakDlg::OnSelchangingMaintab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	ShowTab(m_MainTab.GetCurSel(), FALSE);

	*pResult = 0;
}

void CBoBTweakDlg::OnSelchangeMaintab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	ShowTab(m_MainTab.GetCurSel(), TRUE);

	*pResult = 0;
}

void CBoBTweakDlg::ShowTab(int index, BOOL show)
{
	CWnd *pControl;
	int nCmdShow;

	if (show)
		nCmdShow = SW_SHOW;
	else
		nCmdShow = SW_HIDE;

	switch (index)
	{
		case 0:
			pControl = GetDlgItem(ID_TESTING_INSTANT_VOCAB);
			pControl->ShowWindow(nCmdShow);
			pControl->SetFocus();
			pControl = GetDlgItem(ID_CHEATS_RESTOCKHATCHERY);
			pControl->ShowWindow(nCmdShow);
			if (nCmdShow == SW_SHOW)
				SetDefID(IDOK);
			break;

		case 1:
			pControl = GetDlgItem(IDC_CHECK_ADVSCIENCEKIT);
			pControl->ShowWindow(nCmdShow);
			pControl = GetDlgItem(IDC_CHECK_SCIENCEKIT);
			pControl->ShowWindow(nCmdShow);
			pControl->SetFocus();
			pControl = GetDlgItem(IDC_CHECK_NEUROSCIENCEKIT);
			pControl->ShowWindow(nCmdShow);
			pControl = GetDlgItem(IDC_CHECK_ETTINGRENDELSELECTOR);
			pControl->ShowWindow(nCmdShow);
			pControl = GetDlgItem(IDC_CHECK_INFINITESCROLL);
			pControl->ShowWindow(nCmdShow);
			if (nCmdShow == SW_SHOW)
				SetDefID(IDOK);
			break;

		case 2:
			pControl = GetDlgItem(IDC_MACRO);
			pControl->ShowWindow(nCmdShow);
			pControl->SetFocus();
			pControl = GetDlgItem(IDC_MACRO_REPLY);
			pControl->ShowWindow(nCmdShow);
			pControl = GetDlgItem(IDC_EXECUTE_MACRO);
			pControl->ShowWindow(nCmdShow);
			if (nCmdShow == SW_SHOW)
				SetDefID(IDC_EXECUTE_MACRO);
			break;
	}

	m_Page = index;
}

void CBoBTweakDlg::SetCheatMode(CString newMode)
{
	LONG nResult;
	HKEY hKey;
	DWORD dwLen;

	m_Privileges = newMode;

	nResult = RegOpenKey(HKEY_CURRENT_USER, _T("Software\\CyberLife Technology\\Creatures 2\\1.0"), &hKey);
	if (nResult == ERROR_SUCCESS)
	{
		dwLen = m_Privileges.GetLength();
		nResult = RegSetValueEx(hKey, _T("Privileges"), NULL, REG_SZ, (LPBYTE)m_Privileges.GetBuffer(0), dwLen);
		m_Privileges.ReleaseBuffer();

		if (nResult == ERROR_SUCCESS)
		{
			UpdateMenus();
			AfxMessageBox(_T("You will need to restart Creatures for this to take effect."), MB_ICONINFORMATION);
		}

		RegCloseKey(hKey);
	}
}

BOOL CBoBTweakDlg::SendCAOSCommand(CString sCommand, CString* sReply)
{
	BOOL bSuccess;
	BSTR bsReply;

	bsReply = SysAllocStringLen(NULL, 1024);

	bSuccess = GetSFC()->FireCommand(1, sCommand, &bsReply);

	if (sReply != NULL)
		*sReply = bsReply;

	SysFreeString(bsReply);

	return bSuccess;
}

void CBoBTweakDlg::UpdateMenus()
{
	CMenu* pMainMenu;
	CMenu* pMenu;

	pMainMenu = GetMenu();

	// Testing menu
	pMenu = pMainMenu->GetSubMenu(1);
	pMenu->CheckMenuItem(ID_TESTING_BURBLE, (m_Burble ? MF_CHECKED : MF_UNCHECKED) | MF_BYCOMMAND);

	// Cheat Modes menu
	pMenu = pMainMenu->GetSubMenu(2);
	pMenu->CheckMenuItem(ID_CHEATMODES_NONE, (m_Privileges == _T("user")) ? MF_CHECKED : MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_CHEATMODES_BLUEBERY4, (m_Privileges == _T("blueberry4$")) ? MF_CHECKED : MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_CHEATMODES_COCONUTGROVE, (m_Privileges == _T("coconutgrove")) ? MF_CHECKED : MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_CHEATMODES_DISABLECDCHECK, m_DisableCDCheck ? MF_CHECKED : MF_UNCHECKED);

	// Window menu
	pMenu = pMainMenu->GetSubMenu(3);
	pMenu->CheckMenuItem(ID_WINDOW_KEEP_ON_TOP, m_KeepOnTop ? MF_CHECKED : MF_UNCHECKED);
}

void CBoBTweakDlg::OnFileNewWorld() 
{
	SendCAOSCommand(CString("sys: cmnd 57600"), NULL);
}

void CBoBTweakDlg::OnFileOpenWorld() 
{
	SendCAOSCommand(CString("sys: cmnd 57601"), NULL);
}

void CBoBTweakDlg::OnFileSaveAs() 
{
	SendCAOSCommand(CString("sys: cmnd 57604"), NULL);
}

void CBoBTweakDlg::OnFileSaveWorld() 
{
	SendCAOSCommand(CString("sys: cmnd 57603"), NULL);
}

void CBoBTweakDlg::OnTestingActivateGameStates() 
{
	SendCAOSCommand(CString("sys: cmnd 32774"), NULL);
}

void CBoBTweakDlg::OnTestingBurble() 
{
	SendCAOSCommand(CString("sys: cmnd 32786"), NULL);

	m_Burble = !m_Burble;

	UpdateMenus();
}

void CBoBTweakDlg::OnTestingCreateFemaleNorn() 
{
	SendCAOSCommand(CString("sys: cmnd 32805"), NULL);
}

void CBoBTweakDlg::OnTestingCreateMaleNorn() 
{
	SendCAOSCommand(CString("sys: cmnd 32804"), NULL);
}

void CBoBTweakDlg::OnTestingEuthanasia() 
{
	SendCAOSCommand(CString("sys: cmnd 32840"), NULL);
}

void CBoBTweakDlg::OnTestingForceAgeing() 
{
	SendCAOSCommand(CString("sys: cmnd 32865"), NULL);
}

void CBoBTweakDlg::OnTestingInfectNorn() 
{
	SendCAOSCommand(CString("sys: cmnd 32807"), NULL);
}

void CBoBTweakDlg::OnTestingInstantGoalDirection() 
{
	SendCAOSCommand(CString("sys: cmnd 33002"), NULL);
}

void CBoBTweakDlg::OnTestingInstantVocab() 
{
	CString sName;
	CString sReply;
	int iAge;

	SendCAOSCommand(CString("dde: putv cage"), &sReply);
	if (sReply == _T("0000"))
		return;

	iAge = _ttoi(sReply);

	SendCAOSCommand(CString("dde: getb cnam"), &sName);

	if (iAge < 2)
	{
		if (AfxMessageBox(sName + " is too young and will be aged to the child life stage for instant vocabulary to take effect. Is this OK?", MB_OKCANCEL) != IDOK)
			return;
	}

	SendCAOSCommand(CString("sys: cmnd 32777"), NULL);

	SendCAOSCommand(CString("dde: putb [") + sName + CString("] cnam"), NULL);

	AfxMessageBox(sName + " has had his/her vocabulary updated and his/her name reregistered.", MB_ICONINFORMATION);
}

void CBoBTweakDlg::OnTestingMarkAllRoomsVisited() 
{
	SendCAOSCommand(CString("sys: cmnd 33006"), NULL);
}

void CBoBTweakDlg::OnTestingResetMutationCount() 
{
	SendCAOSCommand(CString("sys: cmnd 32956"), NULL);
}

void CBoBTweakDlg::OnTestingShowMap() 
{
	SendCAOSCommand(CString("sys: cmnd 32995"), NULL);
}

void CBoBTweakDlg::OnCheatmodesNone() 
{
	SetCheatMode(CString(_T("user")));
}

void CBoBTweakDlg::OnCheatmodesBluebery4() 
{
	SetCheatMode(CString(_T("blueberry4$")));
}

void CBoBTweakDlg::OnCheatmodesCoconutgrove() 
{
	SetCheatMode(CString(_T("coconutgrove")));
}

void CBoBTweakDlg::OnCheatmodesDisablecdcheck() 
{
	LONG nResult;
	HKEY hKey;
	DWORD dwLen;
	CString sTemp;

	m_DisableCDCheck = !m_DisableCDCheck;
	sTemp = "";

	nResult = RegOpenKey(HKEY_LOCAL_MACHINE, _T("Software\\CyberLife Technology\\Creatures 2\\1.0"), &hKey);
	if (nResult == ERROR_SUCCESS)
	{
		if (m_DisableCDCheck)
		{
			dwLen = sTemp.GetLength();
			nResult = RegSetValueEx(hKey, _T("No CD-ROM needed"), NULL, REG_SZ, (LPBYTE)sTemp.GetBuffer(0), dwLen);
			sTemp.ReleaseBuffer();
		}
		else
		{
			nResult = RegDeleteValue(hKey, _T("No CD-ROM needed"));
		}

		if (nResult == ERROR_SUCCESS)
		{
			UpdateMenus();
			AfxMessageBox(_T("You will need to restart Creatures for this to take effect."), MB_ICONINFORMATION);
		}

		RegCloseKey(hKey);
	}
}

void CBoBTweakDlg::OnWindowHide() 
{
	if (IsIconic())
	{
		ShowWindow(SW_RESTORE);
	}
	else
	{
		ShowWindow(SW_MINIMIZE);
	}
}

void CBoBTweakDlg::OnWindowKeepOnTop() 
{
	m_KeepOnTop = !m_KeepOnTop;

	if (m_KeepOnTop)
	{
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		CheckDlgButton(ID_WINDOW_KEEP_ON_TOP, 1);
	}
	else
	{
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		CheckDlgButton(ID_WINDOW_KEEP_ON_TOP, 0);
	}

	UpdateMenus();
}

void CBoBTweakDlg::OnExecuteMacro() 
{
	CString sMacro;
	CString sReply;
	int nPos;
	HCURSOR hPrevCursor;
	
	hPrevCursor = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

	m_Macro.GetWindowText(sMacro);

	if (SendCAOSCommand(sMacro, &sReply))
	{
		nPos = m_Macro.FindString(0, sMacro);
		if (nPos != CB_ERR)
		{
			m_Macro.DeleteString(nPos);
		}

		m_Macro.InsertString(0, sMacro);

		if (m_Macro.GetCount() > 4)
		{
			m_Macro.DeleteString(4);
		}

		m_Macro.SetCurSel(0);

		m_MacroReply.SetWindowText(sReply);
	}

	SetCursor(hPrevCursor);
}

void CBoBTweakDlg::LoadSettings()
{
	CBoBTweakApp* pApp;
	CString sName;
	CString sTemp;
	long i;

	pApp = (CBoBTweakApp*)AfxGetApp();

	m_xPosition = pApp->GetProfileInt(_T("1.x"), _T("X"), -1);
	m_yPosition = pApp->GetProfileInt(_T("1.x"), _T("Y"), -1);
	m_KeepOnTop = pApp->GetProfileInt(_T("1.x"), _T("KeepOnTop"), FALSE);
	m_Page = pApp->GetProfileInt(_T("1.x"), _T("Page"), 0);

	for (i = 1; i <= 4; i++)
	{
		sName.Format("CLIHistory%d", i);
		sTemp = pApp->GetProfileString(_T("1.0"), sName);
		if (!sTemp.IsEmpty())
			m_Macro.AddString(sTemp);
	}
}

void CBoBTweakDlg::SaveSettings()
{
	CBoBTweakApp* pApp;
	CString sName;
	CString sTemp;
	long i;

	pApp = (CBoBTweakApp*)AfxGetApp();

	pApp->WriteProfileInt(_T("1.x"), _T("X"), m_xPosition);
	pApp->WriteProfileInt(_T("1.x"), _T("Y"), m_yPosition);
	pApp->WriteProfileInt(_T("1.x"), _T("KeepOnTop"), m_KeepOnTop);
	pApp->WriteProfileInt(_T("1.x"), _T("Page"), m_Page);

	for (i = 1; i <= m_Macro.GetCount(); i++)
	{
		m_Macro.GetLBText(i - 1, sTemp);
		sName.Format("CLIHistory%d", i);
		pApp->WriteProfileString(_T("1.0"), sName, sTemp);
	}
}

void CBoBTweakDlg::OnCheckAdvsciencekit() 
{
	// game 1 5
	m_AdvancedScienceKit = !m_AdvancedScienceKit;
	
	if (m_AdvancedScienceKit)
		SendCAOSCommand(CString(_T("setv game 1 5 1")), NULL);
	else
		SendCAOSCommand(CString(_T("setv game 1 5 0")), NULL);
}

void CBoBTweakDlg::OnCheckEttingrendelselector() 
{
	// game 2 0
	m_EttinGrendelSelector = !m_EttinGrendelSelector;
	
	if (m_EttinGrendelSelector)
		SendCAOSCommand(CString(_T("setv game 2 0 1")), NULL);
	else
		SendCAOSCommand(CString(_T("setv game 2 0 0")), NULL);
}

void CBoBTweakDlg::OnCheckInfinitescroll() 
{
	// game 2 1
	m_InfiniteScroll = !m_InfiniteScroll;
	
	if (m_InfiniteScroll)
		SendCAOSCommand(CString(_T("setv game 2 1 1")), NULL);
	else
		SendCAOSCommand(CString(_T("setv game 2 1 0")), NULL);
}

void CBoBTweakDlg::OnCheckNeurosciencekit() 
{
	// game 0 6
	m_NeuroscienceKit = !m_NeuroscienceKit;
	
	if (m_NeuroscienceKit)
		SendCAOSCommand(CString(_T("setv game 0 6 1")), NULL);
	else
		SendCAOSCommand(CString(_T("setv game 0 6 0")), NULL);
}

void CBoBTweakDlg::OnCheckSciencekit() 
{
	// game 0 5
	m_ScienceKit = !m_ScienceKit;
	
	if (m_ScienceKit)
		SendCAOSCommand(CString(_T("setv game 0 5 1")), NULL);
	else
		SendCAOSCommand(CString(_T("setv game 0 5 0")), NULL);
}

void CBoBTweakDlg::UpdateGameStateChecks()
{
	CheckDlgButton(IDC_CHECK_ADVSCIENCEKIT, m_AdvancedScienceKit ? 1 : 0);
	CheckDlgButton(IDC_CHECK_ETTINGRENDELSELECTOR, m_EttinGrendelSelector ? 1 : 0);
	CheckDlgButton(IDC_CHECK_INFINITESCROLL, m_InfiniteScroll ? 1 : 0);
	CheckDlgButton(IDC_CHECK_NEUROSCIENCEKIT, m_NeuroscienceKit ? 1 : 0);
	CheckDlgButton(IDC_CHECK_SCIENCEKIT, m_ScienceKit ? 1 : 0);
}

void CBoBTweakDlg::OnCheatsRestockhatchery() 
{
	LONG nResult;
	HKEY hKey;
	DWORD dwIndex;
	DWORD dwLen;
	DWORD dwType;
	TCHAR lpszName[256];
	CStringList sNames;
	POSITION pos;
	CString sName;

	nResult = RegOpenKey(HKEY_CURRENT_USER, _T("Software\\CyberLife Technology\\Creatures 2\\Hatchery\\1.0\\Eggstra"), &hKey);
	if (nResult == ERROR_SUCCESS)
	{
		dwIndex = 0;

		do
		{
			dwLen = 256;
			nResult = RegEnumValue(hKey, dwIndex, lpszName, &dwLen, NULL, &dwType, NULL, NULL);
			if (nResult == ERROR_SUCCESS)
			{
				sNames.AddTail(CString(lpszName));
			}
			dwIndex++;
		} while (nResult != ERROR_NO_MORE_ITEMS);

		if (sNames.GetCount() > 0)
		{
			for (pos = sNames.GetHeadPosition(); pos != NULL;)
			{
				sName = sNames.GetNext(pos);

				nResult = RegSetValueEx(hKey, sName, NULL, REG_SZ, (LPBYTE)"CoolandGroovy\0", 14);
				if (nResult != ERROR_SUCCESS)
				{
					AfxMessageBox(_T("An error occurred while updating the registry."), MB_ICONERROR);
				}
			}
		}

		RegCloseKey(hKey);
	}
}

void CBoBTweakDlg::WinHelp(DWORD dwData, UINT nCmd) 
{
	// We don't want no steenking help
}
